#ifndef Settings_HEADER_INCLUDED
#define Settings_HEADER_INCLUDED

#include <string>
#include <vector>

class Settings
{
public:
	int Read(std::string sFileName);
	int Write(std::string sFileName);
	void SetDefault(void);
	struct Widget {
		std::string debug;
		struct Image {
			std::string alignment;
			int hOffset;
			std::string name;
			std::string src;
			int vOffset;
			Image(void):
				alignment("center"),
				hOffset(250),
				name("sun1"),
				src("Images/Sun.png"),
				vOffset(250)
			{}
		} image;
		struct Text {
			std::string alignment;
			std::string data;
			int hOffset;
			std::string name;
			std::string onMouseUp;
			int size;
			std::string style;
			int vOffset;
			Text(void):
				alignment("center"),
				data("Click Here"),
				hOffset(250),
				name("text1"),
				onMouseUp("sun1.opacity = (sun1.opacity / 100) * 90;"),
				size(36),
				style("bold"),
				vOffset(100)
			{}
		} text;
		struct Window {
			int height;
			std::string name;
			std::string title;
			int width;
			Window(void):
				height(500),
				name("main_window"),
				title("Sample Konfabulator Widget"),
				width(500)
			{}
		} window;
		Widget(void):
			debug("on")
		{}
	} widget;
	Settings(void)
	{}
};

#endif
