#include "Settings.h"
#include <algorithm>
#include <fstream>
#include "json/json.h" //json-cpp, tested with version 0.5
void Settings::SetDefault(void) {
}

int Settings::Read(std::string sFileName) {
	Json::Value root;   // will contains the root value after parsing.
	Json::Reader reader;

	SetDefault();

	try
	{
		std::ifstream ifs(sFileName.c_str());
		std::string strConfig((std::istreambuf_iterator<char>(ifs)), std::istreambuf_iterator<char>());
		ifs.close();
		bool parsingSuccessful = reader.parse( strConfig, root );
		if ( !parsingSuccessful )
		{
			return 2;
		}
	}
	catch(...)
	{
		return 1;
	}
	if (root.type() != Json::objectValue) {
		return 1;
	}

	if (root["widget"].type() != Json::objectValue) {
		return 1;
	}
	widget.debug = root["widget"].get("debug", "on").asString();
	if (root["widget"]["image"].type() != Json::objectValue) {
		return 1;
	}
	widget.image.alignment = root["widget"]["image"].get("alignment", "center").asString();
	widget.image.hOffset = root["widget"]["image"].get("hOffset", 250).asInt();
	widget.image.name = root["widget"]["image"].get("name", "sun1").asString();
	widget.image.src = root["widget"]["image"].get("src", "Images/Sun.png").asString();
	widget.image.vOffset = root["widget"]["image"].get("vOffset", 250).asInt();
	if (root["widget"]["text"].type() != Json::objectValue) {
		return 1;
	}
	widget.text.alignment = root["widget"]["text"].get("alignment", "center").asString();
	widget.text.data = root["widget"]["text"].get("data", "Click Here").asString();
	widget.text.hOffset = root["widget"]["text"].get("hOffset", 250).asInt();
	widget.text.name = root["widget"]["text"].get("name", "text1").asString();
	widget.text.onMouseUp = root["widget"]["text"].get("onMouseUp", "sun1.opacity = (sun1.opacity / 100) * 90;").asString();
	widget.text.size = root["widget"]["text"].get("size", 36).asInt();
	widget.text.style = root["widget"]["text"].get("style", "bold").asString();
	widget.text.vOffset = root["widget"]["text"].get("vOffset", 100).asInt();
	if (root["widget"]["window"].type() != Json::objectValue) {
		return 1;
	}
	widget.window.height = root["widget"]["window"].get("height", 500).asInt();
	widget.window.name = root["widget"]["window"].get("name", "main_window").asString();
	widget.window.title = root["widget"]["window"].get("title", "Sample Konfabulator Widget").asString();
	widget.window.width = root["widget"]["window"].get("width", 500).asInt();
	
	return 0;
}

int Settings::Write(std::string sFileName) {
	Json::Value root;
	Json::StyledWriter writer;

	root["widget"]["debug"] = widget.debug;
	root["widget"]["image"]["alignment"] = widget.image.alignment;
	root["widget"]["image"]["hOffset"] = widget.image.hOffset;
	root["widget"]["image"]["name"] = widget.image.name;
	root["widget"]["image"]["src"] = widget.image.src;
	root["widget"]["image"]["vOffset"] = widget.image.vOffset;
	root["widget"]["text"]["alignment"] = widget.text.alignment;
	root["widget"]["text"]["data"] = widget.text.data;
	root["widget"]["text"]["hOffset"] = widget.text.hOffset;
	root["widget"]["text"]["name"] = widget.text.name;
	root["widget"]["text"]["onMouseUp"] = widget.text.onMouseUp;
	root["widget"]["text"]["size"] = widget.text.size;
	root["widget"]["text"]["style"] = widget.text.style;
	root["widget"]["text"]["vOffset"] = widget.text.vOffset;
	root["widget"]["window"]["height"] = widget.window.height;
	root["widget"]["window"]["name"] = widget.window.name;
	root["widget"]["window"]["title"] = widget.window.title;
	root["widget"]["window"]["width"] = widget.window.width;

	std::string outputConfig = writer.write( root );

	try
	{
		std::ofstream ofs(sFileName.c_str());
		ofs << outputConfig;
		ofs.close();
	}
	catch(...)
	{
		return 1;
	}

	return 0;
}

